Index: trunk/src/lib/graphics/importer/md2Model.cc
===================================================================
--- trunk/src/lib/graphics/importer/md2Model.cc	(revision 8298)
+++ trunk/src/lib/graphics/importer/md2Model.cc	(revision 8309)
@@ -89,5 +89,5 @@
 #define BULK_CONV( _ptr, _num )
 #define BULK_CONV16( _ptr, _num )
-#endif	
+#endif
 
 /********************************************************************************
@@ -103,8 +103,8 @@
   /* this creates the data container via ressource manager */
   if (!modelFileName.empty())
-    this->data = (MD2Data*)ResourceManager::getInstance()->load( 
+    this->data = (MD2Data*)ResourceManager::getInstance()->load(
 			modelFileName, MD2, RP_GAME, skinFileName, scale);
-			
-	//When arriving here it is assumed that everything is in the correct byte order.	
+
+	//When arriving here it is assumed that everything is in the correct byte order.
   if( unlikely(this->data == NULL))
     PRINTF(0)("The model was not found, MD2Model Loader finished abnormaly. Update the data-repos\n");
@@ -125,11 +125,11 @@
   this->pModelInfo.numNormals = 0;
   this->pModelInfo.numTexCoor = this->data->numTexCoor;
-	
+
   this->pModelInfo.pVertices = (float*)this->data->pVertices;
-		
+
   this->pModelInfo.pNormals = NULL;
 
   this->pModelInfo.pTexCoor = (float*)this->data->pTexCoor;
-	
+
   // triangle conversion
   this->pModelInfo.pTriangles = new sTriangleExt[this->data->numTriangles];
@@ -388,7 +388,7 @@
   //PRINTF(0)("\n==========================| MD2Model::debug() |===\n");
   PRINTF(0)("=  Model FileName:\t%s\n", this->data->fileName.c_str());
-  PRINTF(0)("=  Skin FileName:\t%s\n", 
+  PRINTF(0)("=  Skin FileName:\t%s\n",
 		this->data->skinFileName.c_str());
-  PRINTF(0)("=  Size in Memory:\t%i Bytes\n", 
+  PRINTF(0)("=  Size in Memory:\t%i Bytes\n",
 		this->data->header->frameSize * this->data->header->numFrames + 64); // 64bytes is the header size
   PRINTF(0)("=  Number of Vertices:\t%i\n", this->data->header->numVertices);
@@ -438,10 +438,10 @@
 MD2Data::~MD2Data()
 {
-  delete this->header;
+/*  delete this->header;
 
   delete [] this->pVertices;
   delete [] this->pGLCommands;
   delete [] this->pLightNormals;
-  delete [] this->pTexCoor;
+  delete [] this->pTexCoor;*/
 }
 
@@ -508,5 +508,5 @@
   /* triangle list */
   fseek(pFile, this->header->offsetTriangles, SEEK_SET);
-  fread(this->pTriangles, sizeof(sTriangle), this->numTriangles, pFile);	
+  fread(this->pTriangles, sizeof(sTriangle), this->numTriangles, pFile);
 	BULK_CONV16( this->pTriangles, this->numTriangles*sizeof(sTriangle)/2 );
 
Index: trunk/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 8298)
+++ trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 8309)
@@ -20,4 +20,5 @@
 #include "debug.h"
 #include "graphics_engine.h"
+#include <stdarg.h>
 
 #ifdef HAVE_SDL_IMAGE_H
@@ -40,4 +41,5 @@
 }
 
+
 /**
  * Destructor of a TextureSequence
@@ -66,25 +68,4 @@
     this->textures.pop_back();
   }
-}
-
-/**
- * @brief rebuilds all the textures from the Images stored in this FrameSequence
- */
-bool TextureSequence::rebuild()
-{
-  PRINTF(3)("Reloading TextureSequence of %s '%s'\n", this->getClassName(), this->getName());
-
-  for (unsigned int i = 0; i < this->textures.size(); i++)
-  {
-    if (glIsTexture(this->textures[i]))
-    {
-      glDeleteTextures(1, &this->textures[i]);
-      this->textures[i] = 0;
-    }
-
-    if (this->images[i] != NULL)
-      this->textures[i] = loadTexToGL(this->images[i]);
-  }
-  return true;
 }
 
@@ -97,22 +78,11 @@
 bool TextureSequence::loadImageSeries(unsigned int count, ...)
 {
+  bool retVal = true;
   va_list textureNameList;
   va_start(textureNameList, count);
 
-  return this->loadImageSeries(count, textureNameList);
-}
-
-/**
- * @brief loads an image Sequence
- * @param count how many images to load to the TextureSequence
- * @param textures the names of the Images to load
- * @returns true on success, false otherwise
- */
-bool TextureSequence::loadImageSeries(unsigned int count, va_list textures)
-{
-  bool retVal = true;
   for (unsigned int i = 0; i < count; i++)
   {
-    if( !this->addFrame(va_arg(textures, char*)))
+    if( !this->addFrame(va_arg(textureNameList, char*)))
       retVal = false;
   }
@@ -120,5 +90,17 @@
 }
 
-bool TextureSequence::loadImageSeries(const std::string& imagePrefix, unsigned int from, unsigned int to, const std::string& extension)
+
+/**
+ * @brief Loads an Image-Series into the TextureSequence.
+ * @param imagePrefix The Prefix of the Image
+ * @param from From which image
+ * @param to To which image
+ * @return true on success.
+ *
+ * @example to load the Files image_001.jpg, image_002.jpg, ... image_099.jpg
+ * use loadImageSeries("image_###.jpg", 0, 99);
+ * @note important is, that the count of ###'s is correct.
+ */
+bool TextureSequence::loadImageSeries(const std::string& imagePrefix, unsigned int from, unsigned int to)
 {
   unsigned int index = 0;
@@ -134,6 +116,4 @@
       frameSize++;
     }
-    _imagePrefix += "." + extension;
-    printf("TESTING %s\n", _imagePrefix.c_str());
 
     PRINTF(4)("Found %d '#'s in %s... searching for LOD's\n", frameSize, imagePrefix.c_str());
@@ -150,4 +130,5 @@
 }
 
+
 /**
  * @brief adds a new Frame to this Sequence (at the end)
@@ -198,12 +179,24 @@
 }
 
-/**
- * @brief moves to the n'th texture which can then be retrieved via the Texture function: this->getTexture()
- * @param frameNumber the n-th frame
- */
-/*void TextureSequence::gotoFrame(unsigned int frameNumber)
-{
-  if (this->textures.size() > frameNumber)
-    this->setTexture(this->textures[frameNumber]);
-}
-*/
+
+
+/**
+ * @brief rebuilds all the textures from the Images stored in this FrameSequence
+ */
+bool TextureSequence::rebuild()
+{
+  PRINTF(3)("Reloading TextureSequence of %s '%s'\n", this->getClassName(), this->getName());
+
+  for (unsigned int i = 0; i < this->textures.size(); i++)
+  {
+    if (glIsTexture(this->textures[i]))
+    {
+      glDeleteTextures(1, &this->textures[i]);
+      this->textures[i] = 0;
+    }
+
+    if (this->images[i] != NULL)
+      this->textures[i] = loadTexToGL(this->images[i]);
+  }
+  return true;
+}
Index: trunk/src/lib/graphics/importer/texture_sequence.h
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.h	(revision 8298)
+++ trunk/src/lib/graphics/importer/texture_sequence.h	(revision 8309)
@@ -10,5 +10,4 @@
 
 #include <vector>
-#include <stdarg.h>
 
 
@@ -18,10 +17,11 @@
   public:
     TextureSequence(unsigned int count = 0, ...);
-  //  Texture(TEXTURE_TYPE type, int resolution);
+    TextureSequence(const std::vector<std::string>*& textureNames);
+    //  Texture(TEXTURE_TYPE type, int resolution);
     virtual ~TextureSequence();
 
     bool loadImageSeries(unsigned int count, ...);
-    bool loadImageSeries(unsigned int count, va_list textureNames);
-    bool loadImageSeries(const std::string& imagePrefix, unsigned int from, unsigned int to, const std::string& extension = "png");
+    bool loadImageSeries(unsigned int count, std::vector<std::string>& textureNames);
+    bool loadImageSeries(const std::string& imagePrefix, unsigned int from, unsigned int to);
     bool addFrame(const std::string& image);
     bool addFrame(SDL_Surface* surface);