Index: trunk/src/lib/graphics/importer/height_map.cc
===================================================================
--- trunk/src/lib/graphics/importer/height_map.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/height_map.cc	(revision 8316)
@@ -108,5 +108,4 @@
 
   float height = 0;
-  int offset = 0;
 
   float r = 0.0;
@@ -474,7 +473,5 @@
   Vector v = State::getCameraNode()->getAbsCoor();
 
-  int i_min = 0;
   int i_max = (heightMap->h )/ HM_TILE_SIZE;
-  int j_min = 0;
   int j_max= (heightMap->w  ) / HM_TILE_SIZE;
 
Index: trunk/src/lib/graphics/importer/material.cc
===================================================================
--- trunk/src/lib/graphics/importer/material.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/material.cc	(revision 8316)
@@ -169,4 +169,6 @@
   }
   Material::selectedMaterial = this;
+
+  return true;
 }
 
@@ -411,5 +413,5 @@
 void Material::setAmbientMap(const std::string& aMap, GLenum target)
 {
-  SDL_Surface* ambientMap;
+  /// FIXME SDL_Surface* ambientMap;
 
 }
@@ -422,5 +424,5 @@
 void Material::setSpecularMap(const std::string& sMap, GLenum target)
 {
-  SDL_Surface* specularMap;
+  /// FIXME SDL_Surface* specularMap;
 
 }
@@ -437,5 +439,5 @@
 
 
-int Material::getMaxTextureUnits()
+unsigned int Material::getMaxTextureUnits()
 {
   int maxTexUnits = 0;
Index: trunk/src/lib/graphics/importer/material.h
===================================================================
--- trunk/src/lib/graphics/importer/material.h	(revision 8312)
+++ trunk/src/lib/graphics/importer/material.h	(revision 8316)
@@ -69,5 +69,5 @@
     static const GLenum glTextureArbs[];  //!< The Texture ARB's
 
-    static int getMaxTextureUnits();
+    static unsigned int getMaxTextureUnits();
 
   private:
Index: trunk/src/lib/graphics/importer/md2Model.cc
===================================================================
--- trunk/src/lib/graphics/importer/md2Model.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/md2Model.cc	(revision 8316)
@@ -290,5 +290,5 @@
 {
   //static sVec3D this->verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
-  int* pCommands = this->data->pGLCommands;
+//  int* pCommands = this->data->pGLCommands;
   /* some face culling stuff */
 //   glPushAttrib(GL_POLYGON_BIT);
@@ -541,4 +541,5 @@
   delete [] buffer;
   fclose(pFile);
+  return true;
 }
 
@@ -563,3 +564,4 @@
   this->material.setIllum(3);
   this->material.setAmbient(1.0, 1.0, 1.0);
-}
+  return true;
+}
Index: trunk/src/lib/graphics/importer/media_container.cc
===================================================================
--- trunk/src/lib/graphics/importer/media_container.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/media_container.cc	(revision 8316)
@@ -182,5 +182,5 @@
 
   // get all the frames and save them in the sequence
-  while(this->addFrame(this->getNextFrame()) != NULL);
+  while(this->addFrame(this->getNextFrame()) != 0);
 }
 
Index: trunk/src/lib/graphics/importer/model.cc
===================================================================
--- trunk/src/lib/graphics/importer/model.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/model.cc	(revision 8316)
@@ -67,5 +67,5 @@
 
   glBegin(GL_TRIANGLES);
-  for( int i = 0; i < this->pModelInfo.numTriangles; ++i)
+  for(unsigned int i = 0; i < this->pModelInfo.numTriangles; ++i)
     {
       //printf("int i = %i\n", i);
Index: trunk/src/lib/graphics/importer/primitive_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/primitive_model.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/primitive_model.cc	(revision 8316)
@@ -105,7 +105,7 @@
   // defining the binding Faces.
   int v1, v2, v3, v4;
-  for (int i = 0; i <= detail * 2 -1; i++)
-  {
-    for (int j = 0; j <= detail; j++)
+  for (unsigned int i = 0; i <= detail * 2 -1; i++)
+  {
+    for (unsigned int j = 0; j <= detail; j++)
     {
 
@@ -147,5 +147,5 @@
   if (detail <= 3)
     detail = 3;
-  int count = 0;
+  unsigned int count = 0;
   // defining Points of the Cylinder.
   for (float phi = 0.0; phi < 2.0*PI; phi += 2.0*PI/(float)detail)
@@ -163,5 +163,5 @@
   }
   // adding Faces
-  for (int i = 0; i < detail-1; i++)
+  for (unsigned int i = 0; i < detail-1; i++)
   {
     int p1, p2, p3, p4;
@@ -204,9 +204,9 @@
 
   //defining Faces
-  for (int i = 0; i < detail; i++)
+  for (unsigned int i = 0; i < detail; i++)
   {
     unsigned int v1, v2;
     v1 = i+2;
-    if (i == detail -1)
+    if (i+1 == detail)
       v2 = 2;
     else
@@ -225,6 +225,6 @@
 {
   //defining vertices
-  for (int i = 0; i < detail; i++)
-    for (int j = 0; j < detail; j++)
+  for (unsigned int i = 0; i < detail; i++)
+    for (unsigned int j = 0; j < detail; j++)
     {
       this->addVertex(((float)i/(float)(detail-1) -.5)*size,
@@ -236,6 +236,6 @@
   //defining Faces
   int v1, v2, v3, v4;
-  for (int i = 0; i < detail-1; i++)
-    for (int j = 0; j < detail-1; j++)
+  for (unsigned int i = 0; i < detail-1; i++)
+    for (unsigned int j = 0; j < detail-1; j++)
     {
       v1 = i*detail + j;
Index: trunk/src/lib/graphics/importer/static_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/static_model.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/static_model.cc	(revision 8316)
@@ -386,4 +386,5 @@
   }
   ++this->groupCount;
+  return true;
 }
 
@@ -558,4 +559,5 @@
   this->currentGroup->faceCount += this->currentGroup->currentFace->vertexCount -2;
   this->faceCount += this->currentGroup->currentFace->vertexCount -2;
+  return true;
 }
 
@@ -591,4 +593,5 @@
   this->currentGroup->faceCount += this->currentGroup->currentFace->vertexCount - 2;
   this->faceCount += this->currentGroup->currentFace->vertexCount -2;
+  return true;
 }
 
@@ -606,4 +609,5 @@
   if (this->currentGroup->faceCount == 0)
     this->currentGroup->faceCount++;
+  return true;
 }
 
@@ -621,4 +625,5 @@
   if (this->currentGroup->faceCount == 0)
     this->currentGroup->faceCount++;
+  return true;
 }
 
@@ -637,9 +642,7 @@
 
   Vector* normArray = new Vector [vertices.size()/3];
-  for (int i=0; i<vertices.size()/3;i++)
+  for (unsigned int i=0; i<vertices.size()/3;i++)
     normArray[i] = Vector(.0,.0,.0);
 
-  int firstTouch;
-  int secondTouch;
   Vector prevV;
   Vector nextV;
@@ -668,5 +671,5 @@
 
         curElem = firstElem;
-        for (int j=0; j<tmpFace->vertexCount; j++)
+        for (unsigned int j = 0; j < tmpFace->vertexCount; j++)
         {
           if (!(nextElem = curElem->next))
@@ -696,5 +699,5 @@
   }
 
-  for (int i=0; i < this->vertices.size()/3;i++)
+  for (unsigned int i=0; i < this->vertices.size()/3;i++)
   {
     normArray[i].normalize();
@@ -705,4 +708,5 @@
   }
   delete[] normArray;
+  return true;
 }
 
@@ -741,5 +745,4 @@
           glEnd();
         this->currentGroup->faceMode = 0;
-        Material* tmpMat;
         if (tmpFace->material != NULL)
         {
@@ -797,4 +800,5 @@
     this->currentGroup = this->currentGroup->next;
   }
+  return true;
 }
 
@@ -933,7 +937,7 @@
   PRINTF(5)("importing grafical Element to openGL.\n");
 
-  if (elem->texCoordNumber != -1)
-  {
-    if (likely(elem->texCoordNumber < this->pModelInfo.numTexCoor))
+  if (elem->texCoordNumber > -1)
+  {
+    if (likely((unsigned int)elem->texCoordNumber < this->pModelInfo.numTexCoor))
       glTexCoord2fv(&this->vTexture[0] + elem->texCoordNumber * 2);
     else
@@ -941,7 +945,7 @@
                 elem->texCoordNumber, this->pModelInfo.numTexCoor);
   }
-  if (elem->normalNumber != -1)
-  {
-    if (likely(elem->normalNumber < this->pModelInfo.numNormals))
+  if (elem->normalNumber > -1)
+  {
+    if (likely((unsigned int)elem->normalNumber < this->pModelInfo.numNormals))
       glNormal3fv(&this->normals[0] + elem->normalNumber * 3);
     else
@@ -949,7 +953,7 @@
                 elem->normalNumber, this->pModelInfo.numNormals);
   }
-  if (elem->vertexNumber != -1)
-  {
-    if (likely(elem->vertexNumber < this->pModelInfo.numVertices))
+  if (elem->vertexNumber > -1)
+  {
+    if (likely((unsigned int)elem->vertexNumber < this->pModelInfo.numVertices))
       glVertex3fv(&this->vertices[0]+ elem->vertexNumber * 3);
     else
@@ -958,4 +962,5 @@
   }
 
+  return true;
 }
 
Index: trunk/src/lib/graphics/importer/tc.cc
===================================================================
--- trunk/src/lib/graphics/importer/tc.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/tc.cc	(revision 8316)
@@ -707,5 +707,5 @@
     if(tc->UsingStaticVerts) {
         double edgeTotal;
-	for(i = 0; i < tc->VertRange; i++) {
+        for(i = 0; i < (int)tc->VertRange; i++) {
 	    v = &tc->StaticVerts[i];
 	    if(v->Count > 0) {
@@ -830,5 +830,5 @@
 {
     int i;
-    int size;
+    int size = 1;
     ACTCVertex *v;
 
@@ -838,5 +838,5 @@
     if(tc->UsingStaticVerts) {
         size = tc->VertRange * sizeof(ACTCVertex);
-        for(i = 0; i < tc->VertRange; i++) {
+        for(i = 0; i < (int)tc->VertRange; i++) {
 	    v = &tc->StaticVerts[i];
 	    if(v->Count > 0)
@@ -915,5 +915,5 @@
 
 	case ACTC_IN_MAX_VERT:
-	    if(value < tc->MinInputVert) {
+          if(value < (int)tc->MinInputVert) {
 		ACTC_DEBUG(fprintf(stderr, "actcParami : tried to set "
 		    "MAX_INPUT_VERT to %d, less than MIN_INPUT_VERT (%d)\n",
@@ -925,5 +925,5 @@
 
 	case ACTC_IN_MIN_VERT:
-	    if(value > tc->MaxInputVert) {
+          if(value > (int)tc->MaxInputVert) {
 		ACTC_DEBUG(fprintf(stderr, "actcParami : tried to set "
 		    "MIN_INPUT_VERT to %d, greater than MAX_INPUT_VERT (%d)\n",
@@ -1065,5 +1065,5 @@
 static int mapVertexEdge(ACTCData *tc, ACTCVertex *v1, ACTCVertex *v2, ACTCEdge **edge)
 {
-    unsigned int i;
+    int i;
     ACTCEdge tmp;
     void *r;
Index: trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture.cc	(revision 8312)
+++ trunk/src/lib/graphics/importer/texture.cc	(revision 8316)
@@ -33,5 +33,5 @@
 /*
  * On the BIG_ENDIAN architecture, the 24 and 32bit bitmaps have
- * different masks. If you don't do this distinction properly, 
+ * different masks. If you don't do this distinction properly,
  * you will get weird-looking textures.
  */
@@ -161,6 +161,6 @@
   unsigned int* pixels = new unsigned int[width * height * channels];
   memset(pixels, 0, width * height * channels * sizeof(unsigned int));
-  
-  
+
+
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
@@ -169,7 +169,7 @@
 
   glTexImage2D(target, 0, channels, width, height, 0, type, GL_UNSIGNED_INT, pixels);
-  
-  
-  
+
+
+
   delete[] pixels;
 
@@ -309,5 +309,5 @@
 
 	Uint32* mask = opaqueMask;
-	
+
   /* Save the alpha blending attributes */
   saved_flags = surface->flags&(SDL_SRCALPHA | SDL_RLEACCELOK);
@@ -320,5 +320,5 @@
 		mask = alphaMask;
   }
-		
+
   retSurface = SDL_CreateRGBSurface(SDL_HWSURFACE,
                                     surface->w, surface->h,
@@ -360,7 +360,7 @@
   int      errorCode = 0;           //!< the error code for the texture loading functions
   GLuint   texture = 0;             //!< the OpenGL texture handle
-  int      mipmapLevel = 0;         //!< the maximum mipmap level for this texture
-  int      mipmapWidth = 0;         //!< the width of the mipmap
-  int      mipmapHight = 0;         //!< the height of the mipmap
+  //int      mipmapLevel = 0;         //!< the maximum mipmap level for this texture
+  //int      mipmapWidth = 0;         //!< the width of the mipmap
+  //int      mipmapHight = 0;         //!< the height of the mipmap
   GLenum   format = GL_RGB;
   if (surface->format->BitsPerPixel == 32)