Index: code/branches/kicklib2/bin/CMakeLists.txt
===================================================================
--- code/branches/kicklib2/bin/CMakeLists.txt	(revision 8315)
+++ code/branches/kicklib2/bin/CMakeLists.txt	(revision 8317)
@@ -69,4 +69,4 @@
 # Make a symlink to be able to run from the root directory when installing copyable on Unix
 IF(UNIX AND INSTALL_COPYABLE)
-  INSTAll(CODE "EXECUTE_PROCESS(COMMAND ln -sf ${RUNTIME_INSTALL_DIRECTORY}/${ORXONOX_EXECUTABLE_NAME} ${CMAKE_INSTALL_PREFIX}/orxonox)")
+  INSTAll(CODE "EXECUTE_PROCESS(COMMAND cmake -E create_symlink \"${CMAKE_INSTALL_PREFIX}/${RUNTIME_INSTALL_DIRECTORY}/${ORXONOX_EXECUTABLE_NAME}\" \"${CMAKE_INSTALL_PREFIX}/${ORXONOX_EXECUTABLE_NAME}\")")
 ENDIF()
Index: code/branches/kicklib2/cmake/InstallConfig.cmake
===================================================================
--- code/branches/kicklib2/cmake/InstallConfig.cmake	(revision 8315)
+++ code/branches/kicklib2/cmake/InstallConfig.cmake	(revision 8317)
@@ -39,23 +39,27 @@
 ENDIF()
 
-# Default installation paths
-SET(RUNTIME_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/${DEFAULT_RUNTIME_PATH})
-SET(LIBRARY_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/${DEFAULT_LIBRARY_PATH})
-SET(ARCHIVE_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/${DEFAULT_ARCHIVE_PATH})
-SET(MODULE_INSTALL_DIRECTORY  ${CMAKE_INSTALL_PREFIX}/${DEFAULT_MODULE_PATH})
-SET(DOC_INSTALL_DIRECTORY     ${CMAKE_INSTALL_PREFIX}/${DEFAULT_DOC_PATH})
-SET(DATA_INSTALL_DIRECTORY    ${CMAKE_INSTALL_PREFIX}/${DEFAULT_DATA_PATH})
-SET(CONFIG_INSTALL_DIRECTORY  ${CMAKE_INSTALL_PREFIX}/${DEFAULT_CONFIG_PATH})
-SET(LOG_INSTALL_DIRECTORY     ${CMAKE_INSTALL_PREFIX}/${DEFAULT_LOG_PATH})
+# Default relative installation paths
+SET(RUNTIME_INSTALL_DIRECTORY ${DEFAULT_RUNTIME_PATH})
+SET(LIBRARY_INSTALL_DIRECTORY ${DEFAULT_LIBRARY_PATH})
+SET(ARCHIVE_INSTALL_DIRECTORY ${DEFAULT_ARCHIVE_PATH})
+SET(MODULE_INSTALL_DIRECTORY  ${DEFAULT_MODULE_PATH})
+SET(DOC_INSTALL_DIRECTORY     ${DEFAULT_DOC_PATH})
+SET(DATA_INSTALL_DIRECTORY    ${DEFAULT_DATA_PATH})
+SET(CONFIG_INSTALL_DIRECTORY  ${DEFAULT_CONFIG_PATH})
+SET(LOG_INSTALL_DIRECTORY     ${DEFAULT_LOG_PATH})
 
 IF(NOT INSTALL_COPYABLE)
-  IF(UNIX) # Apple too?
+  IF(LINUX)
     # Using absolute paths
-    SET(RUNTIME_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/games)
-    SET(LIBRARY_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/lib/games/orxonox)
-    SET(ARCHIVE_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX}/lib/games/orxonox/static)
-    SET(MODULE_INSTALL_DIRECTORY  ${CMAKE_INSTALL_PREFIX}/lib/games/orxonox/modules)
-    SET(DOC_INSTALL_DIRECTORY     ${CMAKE_INSTALL_PREFIX}/share/doc/orxonox)
-    SET(DATA_INSTALL_DIRECTORY    ${CMAKE_INSTALL_PREFIX}/share/games/orxonox)
+    SET(RUNTIME_INSTALL_DIRECTORY games)
+    SET(LIBRARY_INSTALL_DIRECTORY lib/games/orxonox)
+    SET(ARCHIVE_INSTALL_DIRECTORY lib/games/orxonox/static)
+    SET(MODULE_INSTALL_DIRECTORY  lib/games/orxonox/modules)
+    SET(DOC_INSTALL_DIRECTORY     share/doc/orxonox)
+    SET(DATA_INSTALL_DIRECTORY    share/games/orxonox)
+  ELSEIF(WIN32)
+    # Leave on default (installs to only one location anyway)
+  ELSEIF(APPLE)
+    # TODO: Figure out what's the best way to install the application
   ENDIF()
 
@@ -75,5 +79,5 @@
   SET(CMAKE_INSTALL_RPATH ${DEFAULT_LIBRARY_PATH})
 ELSE()
-  SET(CMAKE_INSTALL_RPATH ${LIBRARY_INSTALL_DIRECTORY})
+  SET(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/${LIBRARY_INSTALL_DIRECTORY})
 ENDIF()
 
Index: code/branches/kicklib2/cmake/tools/TargetUtilities.cmake
===================================================================
--- code/branches/kicklib2/cmake/tools/TargetUtilities.cmake	(revision 8315)
+++ code/branches/kicklib2/cmake/tools/TargetUtilities.cmake	(revision 8317)
@@ -289,7 +289,7 @@
   # RPATH settings for the installation
   IF(UNIX)
-    SET(_rpath ${LIBRARY_INSTALL_DIRECTORY})
+    SET(_rpath ${CMAKE_INSTALL_PREFIX}/${LIBRARY_INSTALL_DIRECTORY})
     IF(_arg_MODULE)
-      LIST(APPEND _rpath ${MODULE_INSTALL_DIRECTORY})
+      LIST(APPEND _rpath ${CMAKE_INSTALL_PREFIX}/${MODULE_INSTALL_DIRECTORY})
     ENDIF()
     SET_TARGET_PROPERTIES(${_target_name} PROPERTIES INSTALL_RPATH "${_rpath}")
Index: code/branches/kicklib2/src/SpecialConfig.h.in
===================================================================
--- code/branches/kicklib2/src/SpecialConfig.h.in	(revision 8315)
+++ code/branches/kicklib2/src/SpecialConfig.h.in	(revision 8317)
@@ -67,6 +67,6 @@
 #ifndef INSTALL_COPYABLE
     // INSTALLATION PATHS
-    const char dataInstallDirectory[]       = "@DATA_INSTALL_DIRECTORY@";
-    const char moduleInstallDirectory[]     = "@MODULE_INSTALL_DIRECTORY@";
+    const char dataInstallDirectory[]       = "@CMAKE_INSTALL_PREFIX@/@DATA_INSTALL_DIRECTORY@";
+    const char moduleInstallDirectory[]     = "@CMAKE_INSTALL_PREFIX@/@MODULE_INSTALL_DIRECTORY@";
 #endif
 