Index: /branches/bsp_model/src/defs/class_id.h
===================================================================
--- /branches/bsp_model/src/defs/class_id.h	(revision 8337)
+++ /branches/bsp_model/src/defs/class_id.h	(revision 8338)
@@ -193,4 +193,5 @@
   CL_TURBINE_HOVER              =    0x0000035f,
   CL_SPECTATOR                  =    0x00000360,
+  CL_COLLISION_PROBE            =    0x00000361,
 
   // Powerups
Index: /branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc
===================================================================
--- /branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8337)
+++ /branches/bsp_model/src/lib/collision_reaction/cr_physics_ground_walk.cc	(revision 8338)
@@ -64,5 +64,5 @@
 
   collision->getEntityB()->setVelocity(Vector());
-  collision->getEntityB()->setAbsCoor(this->lastPositions[6]);
+  collision->getEntityB()->setAbsCoor(this->lastPositions[5]);
 }
 
Index: /branches/bsp_model/src/world_entities/WorldEntities.am
===================================================================
--- /branches/bsp_model/src/world_entities/WorldEntities.am	(revision 8337)
+++ /branches/bsp_model/src/world_entities/WorldEntities.am	(revision 8338)
@@ -15,5 +15,5 @@
                 world_entities/test_entity.cc \
                 world_entities/planet.cc \
-		world_entities/bsp_entity.cc \
+                world_entities/bsp_entity.cc \
                 \
                 world_entities/weapons/test_gun.cc \
@@ -39,4 +39,5 @@
                 world_entities/space_ships/hover.cc \
                 world_entities/space_ships/turbine_hover.cc \
+                world_entities/space_ships/collision_probe.cc \
                 world_entities/creatures/md2_creature.cc \
                 world_entities/spectator.cc \
@@ -68,5 +69,5 @@
                 test_entity.h \
                 planet.h \
-		bsp_entity.h \
+                bsp_entity.h \
                 \
                 weapons/test_gun.h \
@@ -92,4 +93,5 @@
                 space_ships/hover.h \
                 space_ships/turbine_hover.h \
+                space_ships/collision_probe.cc \
                 creatures/md2_creature.h \
                 spectator.h \
Index: /branches/bsp_model/src/world_entities/space_ships/collision_probe.cc
===================================================================
--- /branches/bsp_model/src/world_entities/space_ships/collision_probe.cc	(revision 8338)
+++ /branches/bsp_model/src/world_entities/space_ships/collision_probe.cc	(revision 8338)
@@ -0,0 +1,111 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "collision_probe.h"
+
+#include "util/loading/factory.h"
+#include "util/loading/load_param.h"
+
+#include "md2Model.h"
+
+
+using namespace std;
+
+CREATE_FACTORY(CollisionProbe, CL_COLLISION_PROBE);
+
+
+/**
+ *  destructs the spaceship, deletes alocated memory
+ */
+CollisionProbe::~CollisionProbe ()
+{}
+
+
+/**
+ *  creates a new Spaceship from Xml Data
+ * @param root the xml element containing spaceship data
+
+   @todo add more parameters to load
+*/
+CollisionProbe::CollisionProbe(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+
+}
+
+
+/**
+ * initializes a Spaceship
+ */
+void CollisionProbe::init()
+{
+  this->setClassID(CL_COLLISION_PROBE, "CollisionProbe");
+
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
+
+  this->setHealthMax(100);
+  this->setHealth(80);
+
+  this->toList(OM_GROUP_01);
+  this->loadMD2Texture("maps/dr_freak.pcx");
+  this->loadModel("models/dr_freak.md2");
+}
+
+
+/**
+ * loads the Settings of a CollisionProbe from an XML-element.
+ * @param root the XML-element to load the Spaceship's properties from
+ */
+void CollisionProbe::loadParams(const TiXmlElement* root)
+{
+  Playable::loadParams(root);
+}
+
+
+
+/**
+ *  draws the spaceship after transforming it.
+*/
+void CollisionProbe::draw () const
+{
+  WorldEntity::draw();
+}
+
+
+/**
+ *  the function called for each passing timeSnap
+ * @param time The timespan passed since last update
+ */
+void CollisionProbe::tick (float time)
+{
+  if( likely(this->getModel(0) != NULL))
+    ((MD2Model*)this->getModel(0))->tick(time);
+}
+
+/**
+ * @todo switch statement ??
+ */
+void CollisionProbe::process(const Event &event)
+{
+
+}
+
+
+
+
Index: /branches/bsp_model/src/world_entities/space_ships/collision_probe.h
===================================================================
--- /branches/bsp_model/src/world_entities/space_ships/collision_probe.h	(revision 8338)
+++ /branches/bsp_model/src/world_entities/space_ships/collision_probe.h	(revision 8338)
@@ -0,0 +1,57 @@
+/*!
+ * @file space_ship.h
+ * Implements the Control of a Spaceship
+ */
+
+#ifndef _COLLISION_PROBE_H
+#define _COLLISION_PROBE_H
+
+#include "playable.h"
+
+class Vector;
+
+
+class CollisionProbe : public Playable
+{
+
+  public:
+    CollisionProbe(const std::string& fileName);
+    CollisionProbe(const TiXmlElement* root = NULL);
+    virtual ~CollisionProbe();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void tick(float time);
+    virtual void draw() const;
+
+    virtual void process(const Event &event);
+
+    virtual void enter() {}
+    virtual void leave() {}
+    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f) {}
+
+  private:
+    void init();
+
+
+    bool                  bUp;                //!< up button pressed.
+    bool                  bDown;              //!< down button pressed.
+    bool                  bLeft;              //!< left button pressed.
+    bool                  bRight;             //!< right button pressed.
+    bool                  bAscend;            //!< ascend button pressed.
+    bool                  bDescend;           //!< descend button presses.
+//    bool                  bFire;              //!< fire button pressed.(moved to playable)
+    bool                  bRollL;             //!< rolling button pressed (left)
+    bool                  bRollR;             //!< rolling button pressed (right)
+
+    float                 xMouse;             //!< mouse moved in x-Direction
+    float                 yMouse;             //!< mouse moved in y-Direction
+    float                 mouseSensitivity;   //!< the mouse sensitivity
+    int                   yInvert;
+    int                   controlVelocityX;
+    int                   controlVelocityY;
+
+
+};
+
+#endif /* _SPACE_SHIPS_H */